﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using Microsoft.Practices.Prism.Commands;

namespace WpfApplication143
{
    public class ViewModel
    {
        public ObservableCollection<Person> People { get; set; }
        private string[] names = { "John", "Kim", "Sandy", "Mark", "Josh", "Jim", "Sam", "Mary", 
                                     "Harry", "Sue", "Chris", "Joe", "Carl" };
       
       
        public ViewModel()
        {
            Random r = new Random();
            People = new ObservableCollection<Person>();
            for (int i = 0; i < 500; i++)
            {
                People.Add(new Person()
                {
                     ID =i,
                     Name = names[r.Next(13)],
                     Age = r.Next(10,40),
                     CanUpdate = true
                });
            }
            this.Command = new DelegateCommand<Person>(DoCommand, CanDoCommand);
            
        }

        public DelegateCommand<Person> Command
        {
            get;
            set;
        }

        private void DoCommand(Person param)
        {
            if (param != null)
                param.CanUpdate = false;

           // this.Command.RaiseCanExecuteChanged();

        }

        private bool CanDoCommand(Person param)
        {
            if (param != null)
                return param.CanUpdate;
            else
                return true;
        }
    }
}
