﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.ComponentModel;
using Microsoft.Practices.Prism.Commands;

namespace WpfApplication143
{
    public  class Person:INotifyPropertyChanged
    {
        private bool allowCmd = true;
        public Person()
        {
           
        }
        string name = string.Empty;
        public string Name
        {
            get {return name;}
            set { name = value;
            NotifyPropertyChanged("Name");
            }
        }

        int id;
        public int ID
        {
            get { return id; }
            set
            {
                id = value;
                NotifyPropertyChanged("ID");
            }
        }

        int age = 0;
        public int Age
        {
            get { return age; }
            set { age = value;
            NotifyPropertyChanged("Age");
            }
        }

        bool canUpdate = false;
        public bool CanUpdate
        {
            get { return canUpdate; }
            set
            {
                canUpdate = value;
                NotifyPropertyChanged("CanUpdate");
            }
        }

      

        private bool CanDoCommand()
        {
            return allowCmd;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }


    }
}
